/* sudoku-cell.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_POPOVER_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_PAUSED_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL,
	SUDOKU_CELL_NUM_SIGNALS
};
static guint sudoku_cell_signals[SUDOKU_CELL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkPopover* _popover;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _paused;
	gboolean control_key_pressed;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

struct _Block11Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* number_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_cell_set_fixed_css (SudokuCell* self,
                                gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void __lambda10_ (SudokuCell* self);
static void ___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                      gpointer self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint num);
static void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
VALA_EXTERN void sudoku_cell_initialize_earmarks (SudokuCell* self,
                                      gboolean show_possibilities,
                                      gboolean force);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda9_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda8_ (Block11Data* _data11_,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self,
                                       gboolean show_extra_warnings);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_paused (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static void
sudoku_cell_set_fixed_css (SudokuCell* self,
                           gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_get_is_fixed (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		if (enabled) {
			gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
		} else {
			gtk_widget_remove_css_class ((GtkWidget*) self, "fixed");
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp3_;
	gint _tmp3__length1;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, val)) {
		return;
	}
	_tmp3_ = self->priv->earmark_labels;
	_tmp3__length1 = self->priv->earmark_labels_length1;
	_tmp4_ = _tmp3_[val - 1];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	earmark = _tmp5_;
	if (enabled) {
		GtkLabel* _tmp7_;
		_tmp7_ = earmark;
		_tmp6_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp7_, "error");
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GtkLabel* _tmp8_;
		_tmp8_ = earmark;
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "highlight-label");
	} else {
		GtkLabel* _tmp9_;
		_tmp9_ = earmark;
		gtk_widget_remove_css_class ((GtkWidget*) _tmp9_, "highlight-label");
	}
	_g_object_unref0 (earmark);
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
	return result;
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
}

static void
__lambda10_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = sudoku_cell_get_popover (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
		_tmp4_ = sudoku_cell_get_popover (self);
		_tmp5_ = _tmp4_;
		gtk_popover_set_child (_tmp5_, NULL);
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
}

static void
___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                 gpointer self)
{
	__lambda10_ ((SudokuCell*) self);
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkEventController* _tmp11_;
	GtkGestureLongPress* _tmp12_;
	GtkEventController* _tmp13_;
	GtkEventControllerKey* _tmp14_;
	GtkEventController* _tmp15_;
	GtkGestureLongPress* _tmp16_;
	GtkGestureClick* _tmp17_;
	GtkEventControllerKey* _tmp18_;
	GtkEventControllerKey* _tmp19_;
	GtkLabel* _tmp20_;
	gint num = 0;
	GtkPopover* _tmp42_;
	GtkPopover* _tmp43_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp44_;
	GtkEventControllerKey* _tmp45_;
	GtkEventControllerKey* _tmp46_;
	GtkWidget* _tmp47_ = NULL;
	GtkPopover* _tmp48_;
	GtkPopover* _tmp49_;
	GtkPopover* _tmp52_;
	GtkPopover* _tmp53_;
	g_return_val_if_fail (*game != NULL, NULL);
	self = (SudokuCell*) g_object_new (object_type, NULL);
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
	self->priv->row = row;
	self->priv->col = col;
	_tmp0_ = _g_object_ref0 (*game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != 0) {
		GtkLabel* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
		_tmp3_ = self->priv->value_label;
		_tmp4_ = sudoku_cell_get_value (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
		_tmp7_ = _tmp6_;
		gtk_label_set_label (_tmp3_, _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
	}
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	sudoku_cell_set_fixed_css (self, TRUE);
	_tmp9_ = self->priv->button_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp9_, (guint) 0);
	_tmp10_ = self->priv->button_controller;
	_tmp11_ = _g_object_ref0 ((GtkEventController*) _tmp10_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp11_);
	_tmp12_ = self->priv->long_press_controller;
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
	_tmp14_ = self->priv->key_controller;
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
	_tmp16_ = self->priv->long_press_controller;
	g_signal_connect_object (_tmp16_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
	_tmp17_ = self->priv->button_controller;
	g_signal_connect_object (_tmp17_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
	_tmp18_ = self->priv->key_controller;
	g_signal_connect_object (_tmp18_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
	_tmp19_ = self->priv->key_controller;
	g_signal_connect_object (_tmp19_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
	_tmp20_ = self->priv->value_label;
	gtk_widget_set_parent ((GtkWidget*) _tmp20_, (GtkWidget*) self);
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp21_ = FALSE;
			_tmp21_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				if (!_tmp21_) {
					gint _tmp22_;
					_tmp22_ = row_tmp;
					row_tmp = _tmp22_ + 1;
				}
				_tmp21_ = FALSE;
				_tmp23_ = sudoku_game_get_board (*game);
				_tmp24_ = _tmp23_;
				_tmp25_ = sudoku_board_get_block_rows (_tmp24_);
				_tmp26_ = _tmp25_;
				if (!(row_tmp < _tmp26_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp27_ = FALSE;
						_tmp27_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							gchar* _tmp35_;
							gchar* _tmp36_;
							GtkLabel* _tmp37_ = NULL;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GtkLabel** _tmp40_;
							gint _tmp40__length1;
							GtkLabel* _tmp41_;
							if (!_tmp27_) {
								gint _tmp28_;
								_tmp28_ = col_tmp;
								col_tmp = _tmp28_ + 1;
							}
							_tmp27_ = FALSE;
							_tmp29_ = sudoku_game_get_board (*game);
							_tmp30_ = _tmp29_;
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
							_tmp32_ = _tmp31_;
							if (!(col_tmp < _tmp32_)) {
								break;
							}
							_tmp33_ = num;
							num = _tmp33_ + 1;
							_tmp34_ = self->priv->earmark_labels;
							_tmp34__length1 = self->priv->earmark_labels_length1;
							_tmp35_ = g_strdup_printf ("%i", num);
							_tmp36_ = _tmp35_;
							_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
							gtk_widget_set_visible ((GtkWidget*) _tmp37_, FALSE);
							g_object_ref_sink (_tmp37_);
							_g_object_unref0 (_tmp34_[num - 1]);
							_tmp34_[num - 1] = _tmp37_;
							_g_free0 (_tmp36_);
							_tmp38_ = self->priv->earmark_labels;
							_tmp38__length1 = self->priv->earmark_labels_length1;
							_tmp39_ = _tmp38_[num - 1];
							gtk_widget_set_parent ((GtkWidget*) _tmp39_, (GtkWidget*) self);
							_tmp40_ = self->priv->earmark_labels;
							_tmp40__length1 = self->priv->earmark_labels_length1;
							_tmp41_ = _tmp40_[num - 1];
							gtk_widget_add_css_class ((GtkWidget*) _tmp41_, "earmark");
						}
					}
				}
			}
		}
	}
	_tmp42_ = sudoku_cell_get_popover (self);
	_tmp43_ = _tmp42_;
	gtk_widget_set_parent ((GtkWidget*) _tmp43_, (GtkWidget*) self);
	_tmp44_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	popover_controller = _tmp44_;
	_tmp45_ = popover_controller;
	g_signal_connect_object (_tmp45_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
	_tmp46_ = popover_controller;
	g_signal_connect_object (_tmp46_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
	_tmp48_ = sudoku_cell_get_popover (self);
	_tmp49_ = _tmp48_;
	_tmp47_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp49_) : NULL;
	if (_tmp47_ != NULL) {
		GtkEventControllerKey* _tmp50_;
		GtkEventController* _tmp51_;
		_tmp50_ = popover_controller;
		_tmp51_ = _g_object_ref0 ((GtkEventController*) _tmp50_);
		gtk_widget_add_controller (_tmp47_, _tmp51_);
	}
	_tmp52_ = sudoku_cell_get_popover (self);
	_tmp53_ = _tmp52_;
	g_signal_connect_object (_tmp53_, "closed", (GCallback) ___lambda10__gtk_popover_closed, self, 0);
	_g_object_unref0 (popover_controller);
	return self;
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
}

void
sudoku_cell_update_value (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_get_value (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != 0) {
		GtkLabel* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		_tmp2_ = self->priv->value_label;
		_tmp3_ = sudoku_cell_get_value (self);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
		_tmp6_ = _tmp5_;
		gtk_label_set_label (_tmp2_, _tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
	} else {
		GtkLabel* _tmp8_;
		_tmp8_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
	}
	sudoku_cell_get_visible_earmarks (self);
}

void
sudoku_cell_update_earmark (SudokuCell* self,
                            gint num)
{
	g_return_if_fail (self != NULL);
	sudoku_cell_get_visible_earmark (self, num);
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (keyval == GDK_KEY_Control_L) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = keyval == GDK_KEY_Control_R;
	}
	if (_tmp0_) {
		self->priv->control_key_pressed = TRUE;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp6_ = FALSE;
	gint key = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = sudoku_cell_get_is_fixed (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		SudokuGame* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->game;
		_tmp4_ = sudoku_game_get_paused (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_;
	}
	if (_tmp0_) {
		return;
	}
	if (keyval == GDK_KEY_Control_L) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = keyval == GDK_KEY_Control_R;
	}
	if (_tmp6_) {
		self->priv->control_key_pressed = FALSE;
	}
	key = sudoku_cell_get_key_number (self, keyval);
	if (key >= 1) {
		_tmp7_ = key <= 9;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp8_;
		GtkPopover* _tmp9_;
		GtkWidget* _tmp10_;
		NumberPicker* _tmp11_;
		gboolean ctrl_pressed = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkPopover* _tmp15_;
		GtkPopover* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		gboolean want_earmark = FALSE;
		gboolean _tmp26_ = FALSE;
		_tmp8_ = sudoku_cell_get_popover (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_popover_get_child (_tmp9_);
		_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_NUMBER_PICKER, NumberPicker));
		number_picker = _tmp11_;
		ctrl_pressed = (state & GDK_CONTROL_MASK) > 0;
		_tmp15_ = sudoku_cell_get_popover (self);
		_tmp16_ = _tmp15_;
		_tmp17_ = gtk_widget_get_visible ((GtkWidget*) _tmp16_);
		_tmp18_ = _tmp17_;
		if (_tmp18_) {
			NumberPicker* _tmp19_;
			_tmp19_ = number_picker;
			_tmp14_ = _tmp19_ != NULL;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			NumberPicker* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
			_tmp20_ = number_picker;
			_tmp21_ = number_picker_get_is_earmark_picker (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp13_ = _tmp22_;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			_tmp12_ = TRUE;
		} else {
			gboolean _tmp23_ = FALSE;
			if (ctrl_pressed) {
				gint _tmp24_;
				gint _tmp25_;
				_tmp24_ = sudoku_cell_get_value (self);
				_tmp25_ = _tmp24_;
				_tmp23_ = _tmp25_ == 0;
			} else {
				_tmp23_ = FALSE;
			}
			_tmp12_ = _tmp23_;
		}
		want_earmark = _tmp12_;
		if (want_earmark) {
			SudokuGame* _tmp27_;
			GameMode _tmp28_;
			GameMode _tmp29_;
			_tmp27_ = self->priv->game;
			_tmp28_ = sudoku_game_get_mode (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp26_ = _tmp29_ == GAME_MODE_PLAY;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			gboolean new_state = FALSE;
			SudokuGame* _tmp30_;
			SudokuBoard* _tmp31_;
			SudokuBoard* _tmp32_;
			gboolean _tmp33_ = FALSE;
			NumberPicker* _tmp34_;
			_tmp30_ = self->priv->game;
			_tmp31_ = sudoku_game_get_board (_tmp30_);
			_tmp32_ = _tmp31_;
			new_state = !sudoku_board_is_earmark_enabled (_tmp32_, self->priv->row, self->priv->col, key);
			_tmp34_ = number_picker;
			if (_tmp34_ != NULL) {
				NumberPicker* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
				_tmp35_ = number_picker;
				_tmp36_ = number_picker_get_is_earmark_picker (_tmp35_);
				_tmp37_ = _tmp36_;
				_tmp33_ = _tmp37_;
			} else {
				_tmp33_ = FALSE;
			}
			if (_tmp33_) {
				NumberPicker* _tmp38_;
				_tmp38_ = number_picker;
				number_picker_set_earmark (_tmp38_, self->priv->row, self->priv->col, key - 1, new_state);
			} else {
				if (new_state) {
					SudokuGame* _tmp39_;
					_tmp39_ = self->priv->game;
					sudoku_game_enable_earmark (_tmp39_, self->priv->row, self->priv->col, key);
				} else {
					SudokuGame* _tmp40_;
					_tmp40_ = self->priv->game;
					sudoku_game_disable_earmark (_tmp40_, self->priv->row, self->priv->col, key);
				}
			}
		} else {
			if (!ctrl_pressed) {
				SudokuGame* _tmp41_;
				SudokuBoard* _tmp42_;
				SudokuBoard* _tmp43_;
				sudoku_cell_set_value (self, key);
				_tmp41_ = self->priv->game;
				_tmp42_ = sudoku_game_get_board (_tmp41_);
				_tmp43_ = _tmp42_;
				sudoku_board_disable_all_earmarks (_tmp43_, self->priv->row, self->priv->col);
			}
		}
		_g_object_unref0 (number_picker);
		return;
	}
	if (key == 0) {
		_tmp45_ = TRUE;
	} else {
		_tmp45_ = keyval == GDK_KEY_BackSpace;
	}
	if (_tmp45_) {
		_tmp44_ = TRUE;
	} else {
		_tmp44_ = keyval == GDK_KEY_Delete;
	}
	if (_tmp44_) {
		SudokuGame* _tmp46_;
		SudokuBoard* _tmp47_;
		SudokuBoard* _tmp48_;
		_tmp46_ = self->priv->game;
		_tmp47_ = sudoku_game_get_board (_tmp46_);
		_tmp48_ = _tmp47_;
		if (sudoku_board_has_earmarks (_tmp48_, self->priv->row, self->priv->col)) {
			SudokuGame* _tmp49_;
			_tmp49_ = self->priv->game;
			sudoku_game_disable_all_earmarks (_tmp49_, self->priv->row, self->priv->col);
		}
		sudoku_cell_set_value (self, 0);
		return;
	}
	if (keyval == GDK_KEY_space) {
		_tmp51_ = TRUE;
	} else {
		_tmp51_ = keyval == GDK_KEY_Return;
	}
	if (_tmp51_) {
		_tmp50_ = TRUE;
	} else {
		_tmp50_ = keyval == GDK_KEY_KP_Enter;
	}
	if (_tmp50_) {
		sudoku_cell_show_number_picker (self);
		return;
	}
	if (keyval == GDK_KEY_Escape) {
		GtkPopover* _tmp52_;
		GtkPopover* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
		_tmp52_ = sudoku_cell_get_popover (self);
		_tmp53_ = _tmp52_;
		_tmp54_ = gtk_widget_get_visible ((GtkWidget*) _tmp53_);
		_tmp55_ = _tmp54_;
		if (_tmp55_) {
			GtkPopover* _tmp56_;
			GtkPopover* _tmp57_;
			_tmp56_ = sudoku_cell_get_popover (self);
			_tmp57_ = _tmp56_;
			gtk_popover_popdown (_tmp57_);
		}
		return;
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
	_tmp4_ = sudoku_cell_get_is_fixed (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		_tmp3_ = TRUE;
	} else {
		SudokuGame* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->priv->game;
		_tmp7_ = sudoku_game_get_paused (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp3_ = _tmp8_;
	}
	if (_tmp3_) {
		return;
	}
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		SudokuGame* _tmp11_;
		GameMode _tmp12_;
		GameMode _tmp13_;
		_tmp11_ = self->priv->game;
		_tmp12_ = sudoku_game_get_mode (_tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_ == GAME_MODE_PLAY) {
			GdkEventSequence* _tmp14_;
			GdkEvent* _tmp15_;
			_tmp14_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) gesture);
			_tmp15_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp14_);
			_tmp10_ = (gdk_event_get_modifier_state (_tmp15_) & GDK_CONTROL_MASK) > 0;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			gint _tmp16_;
			gint _tmp17_;
			_tmp16_ = sudoku_cell_get_value (self);
			_tmp17_ = _tmp16_;
			_tmp9_ = _tmp17_ == 0;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			sudoku_cell_show_earmark_picker (self);
		} else {
			sudoku_cell_show_number_picker (self);
		}
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
			SudokuGame* _tmp20_;
			GameMode _tmp21_;
			GameMode _tmp22_;
			_tmp20_ = self->priv->game;
			_tmp21_ = sudoku_game_get_mode (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp19_ = _tmp22_ == GAME_MODE_PLAY;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			gint _tmp23_;
			gint _tmp24_;
			_tmp23_ = sudoku_cell_get_value (self);
			_tmp24_ = _tmp23_;
			_tmp18_ = _tmp24_ == 0;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			sudoku_cell_show_earmark_picker (self);
		}
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SudokuGame* _tmp8_;
	GameMode _tmp9_;
	GameMode _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
	_tmp3_ = sudoku_cell_get_is_fixed (self);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		_tmp2_ = TRUE;
	} else {
		SudokuGame* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->game;
		_tmp6_ = sudoku_game_get_paused (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp2_ = _tmp7_;
	}
	if (_tmp2_) {
		return;
	}
	_tmp8_ = self->priv->game;
	_tmp9_ = sudoku_game_get_mode (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == GAME_MODE_CREATE) {
		sudoku_cell_show_number_picker (self);
	} else {
		gint _tmp11_;
		gint _tmp12_;
		_tmp11_ = sudoku_cell_get_value (self);
		_tmp12_ = _tmp11_;
		if (_tmp12_ == 0) {
			sudoku_cell_show_earmark_picker (self);
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	switch (keyval) {
		case GDK_KEY_0:
		case GDK_KEY_KP_0:
		{
			result = 0;
			return result;
		}
		case GDK_KEY_1:
		case GDK_KEY_KP_1:
		{
			result = 1;
			return result;
		}
		case GDK_KEY_2:
		case GDK_KEY_KP_2:
		{
			result = 2;
			return result;
		}
		case GDK_KEY_3:
		case GDK_KEY_KP_3:
		{
			result = 3;
			return result;
		}
		case GDK_KEY_4:
		case GDK_KEY_KP_4:
		{
			result = 4;
			return result;
		}
		case GDK_KEY_5:
		case GDK_KEY_KP_5:
		{
			result = 5;
			return result;
		}
		case GDK_KEY_6:
		case GDK_KEY_KP_6:
		{
			result = 6;
			return result;
		}
		case GDK_KEY_7:
		case GDK_KEY_KP_7:
		{
			result = 7;
			return result;
		}
		case GDK_KEY_8:
		case GDK_KEY_KP_8:
		{
			result = 8;
			return result;
		}
		case GDK_KEY_9:
		case GDK_KEY_KP_9:
		{
			result = 9;
			return result;
		}
		default:
		{
			result = -1;
			return result;
		}
	}
}

void
sudoku_cell_initialize_earmarks (SudokuCell* self,
                                 gboolean show_possibilities,
                                 gboolean force)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != 0) {
		_tmp0_ = TRUE;
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
		_tmp3_ = self->priv->game;
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
	}
	if (_tmp0_) {
		return;
	}
	if (show_possibilities) {
		gboolean _tmp7_ = FALSE;
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		_tmp8_ = self->priv->game;
		_tmp9_ = sudoku_game_get_board (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = sudoku_board_get_previous_played_time (_tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp12_ == 0.0) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = force;
		}
		_tmp6_ = _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gboolean* marks = NULL;
		SudokuGame* _tmp13_;
		SudokuBoard* _tmp14_;
		SudokuBoard* _tmp15_;
		gint _tmp16_ = 0;
		gboolean* _tmp17_;
		gint marks_length1;
		gint _marks_size_;
		_tmp13_ = self->priv->game;
		_tmp14_ = sudoku_game_get_board (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp17_ = sudoku_board_get_possibilities_as_bool_array (_tmp15_, self->priv->row, self->priv->col, &_tmp16_);
		marks = _tmp17_;
		marks_length1 = _tmp16_;
		_marks_size_ = marks_length1;
		{
			gint num = 0;
			num = 1;
			{
				gboolean _tmp18_ = FALSE;
				_tmp18_ = TRUE;
				while (TRUE) {
					gboolean _tmp20_ = FALSE;
					gboolean* _tmp21_;
					gint _tmp21__length1;
					gboolean _tmp22_;
					if (!_tmp18_) {
						gint _tmp19_;
						_tmp19_ = num;
						num = _tmp19_ + 1;
					}
					_tmp18_ = FALSE;
					if (!(num <= 9)) {
						break;
					}
					_tmp21_ = marks;
					_tmp21__length1 = marks_length1;
					_tmp22_ = _tmp21_[num - 1];
					if (_tmp22_) {
						SudokuGame* _tmp23_;
						SudokuBoard* _tmp24_;
						SudokuBoard* _tmp25_;
						_tmp23_ = self->priv->game;
						_tmp24_ = sudoku_game_get_board (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp20_ = !sudoku_board_is_earmark_enabled (_tmp25_, self->priv->row, self->priv->col, num);
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						SudokuGame* _tmp26_;
						SudokuBoard* _tmp27_;
						SudokuBoard* _tmp28_;
						_tmp26_ = self->priv->game;
						_tmp27_ = sudoku_game_get_board (_tmp26_);
						_tmp28_ = _tmp27_;
						sudoku_board_enable_earmark (_tmp28_, self->priv->row, self->priv->col, num);
					}
				}
			}
		}
		marks = (g_free (marks), NULL);
	}
	sudoku_cell_get_visible_earmarks (self);
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	g_return_if_fail (self != NULL);
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = num;
					num = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(num <= 9)) {
					break;
				}
				sudoku_cell_get_visible_earmark (self, num);
			}
		}
	}
}

static void
sudoku_cell_get_visible_earmark (SudokuCell* self,
                                 gint num)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_get_value (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != 0) {
		GtkLabel** _tmp2_;
		gint _tmp2__length1;
		GtkLabel* _tmp3_;
		_tmp2_ = self->priv->earmark_labels;
		_tmp2__length1 = self->priv->earmark_labels_length1;
		_tmp3_ = _tmp2_[num - 1];
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	} else {
		GtkLabel** _tmp4_;
		gint _tmp4__length1;
		GtkLabel* _tmp5_;
		SudokuGame* _tmp6_;
		SudokuBoard* _tmp7_;
		SudokuBoard* _tmp8_;
		_tmp4_ = self->priv->earmark_labels;
		_tmp4__length1 = self->priv->earmark_labels_length1;
		_tmp5_ = _tmp4_[num - 1];
		_tmp6_ = self->priv->game;
		_tmp7_ = sudoku_game_get_board (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, sudoku_board_is_earmark_enabled (_tmp8_, self->priv->row, self->priv->col, num));
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		SudokuCell* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->earmark_picker);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda9_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	NumberPicker* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuBoard* _tmp11_;
	SudokuBoard* _tmp12_;
	self = _data10_->self;
	if (state) {
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
		_tmp0_ = self->priv->game;
		_tmp1_ = sudoku_game_get_board (_tmp0_);
		_tmp2_ = _tmp1_;
		if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, number)) {
			SudokuGame* _tmp3_;
			_tmp3_ = self->priv->game;
			sudoku_game_enable_earmark (_tmp3_, self->priv->row, self->priv->col, number);
		}
	} else {
		if (number == 0) {
			SudokuGame* _tmp4_;
			_tmp4_ = self->priv->game;
			sudoku_game_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
		} else {
			SudokuGame* _tmp5_;
			SudokuBoard* _tmp6_;
			SudokuBoard* _tmp7_;
			_tmp5_ = self->priv->game;
			_tmp6_ = sudoku_game_get_board (_tmp5_);
			_tmp7_ = _tmp6_;
			if (sudoku_board_is_earmark_enabled (_tmp7_, self->priv->row, self->priv->col, number)) {
				SudokuGame* _tmp8_;
				_tmp8_ = self->priv->game;
				sudoku_game_disable_earmark (_tmp8_, self->priv->row, self->priv->col, number);
			}
		}
	}
	_tmp9_ = _data10_->earmark_picker;
	_tmp10_ = self->priv->game;
	_tmp11_ = sudoku_game_get_board (_tmp10_);
	_tmp12_ = _tmp11_;
	number_picker_set_clear_button_enabled (_tmp9_, sudoku_board_has_earmarks (_tmp12_, self->priv->row, self->priv->col));
}

static void
___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
	__lambda9_ (self, number, active);
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	Block10Data* _data10_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SudokuGame* _tmp12_;
	NumberPicker* _tmp13_;
	NumberPicker* _tmp14_;
	SudokuGame* _tmp15_;
	SudokuBoard* _tmp16_;
	SudokuBoard* _tmp17_;
	NumberPicker* _tmp19_;
	NumberPicker* _tmp20_;
	GtkPopover* _tmp21_;
	GtkPopover* _tmp22_;
	NumberPicker* _tmp23_;
	GtkPopover* _tmp24_;
	GtkPopover* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_get_value (self);
	_tmp1_ = _tmp0_;
	_vala_return_if_fail (_tmp1_ == 0, "this.value == 0");
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp2_ = sudoku_cell_get_popover (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_widget_get_visible ((GtkWidget*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		GtkPopover* _tmp6_;
		GtkPopover* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		sudoku_cell_dismiss_popover (self);
		_tmp6_ = sudoku_cell_get_popover (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = gtk_popover_get_child (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_NUMBER_PICKER, NumberPicker));
		_tmp11_ = _tmp10_;
		if (_tmp11_) {
			block10_data_unref (_data10_);
			_data10_ = NULL;
			return;
		}
	}
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
	_tmp12_ = self->priv->game;
	_tmp13_ = number_picker_new (_tmp12_, TRUE);
	g_object_ref_sink (_tmp13_);
	_data10_->earmark_picker = _tmp13_;
	_tmp14_ = _data10_->earmark_picker;
	number_picker_set_clear_button_visibility (_tmp14_, TRUE);
	_tmp15_ = self->priv->game;
	_tmp16_ = sudoku_game_get_board (_tmp15_);
	_tmp17_ = _tmp16_;
	if (!sudoku_board_has_earmarks (_tmp17_, self->priv->row, self->priv->col)) {
		NumberPicker* _tmp18_;
		_tmp18_ = _data10_->earmark_picker;
		number_picker_set_clear_button_enabled (_tmp18_, FALSE);
	}
	_tmp19_ = _data10_->earmark_picker;
	g_signal_connect_data (_tmp19_, "earmark-state-changed", (GCallback) ___lambda9__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	_tmp20_ = _data10_->earmark_picker;
	number_picker_set_earmarks (_tmp20_, self->priv->row, self->priv->col);
	_tmp21_ = sudoku_cell_get_popover (self);
	_tmp22_ = _tmp21_;
	_tmp23_ = _data10_->earmark_picker;
	gtk_popover_set_child (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = sudoku_cell_get_popover (self);
	_tmp25_ = _tmp24_;
	gtk_popover_popup (_tmp25_);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		SudokuCell* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->number_picker);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
__lambda8_ (Block11Data* _data11_,
            NumberPicker* o,
            gint number)
{
	SudokuCell* self;
	self = _data11_->self;
	g_return_if_fail (o != NULL);
	if (number > 0) {
		GtkPopover* _tmp0_;
		GtkPopover* _tmp1_;
		_tmp0_ = sudoku_cell_get_popover (self);
		_tmp1_ = _tmp0_;
		gtk_popover_popdown (_tmp1_);
	} else {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		NumberPicker* _tmp5_;
		_tmp2_ = self->priv->game;
		_tmp3_ = sudoku_game_get_board (_tmp2_);
		_tmp4_ = _tmp3_;
		sudoku_board_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
		_tmp5_ = _data11_->number_picker;
		number_picker_set_clear_button_visibility (_tmp5_, FALSE);
	}
	sudoku_cell_set_value (self, number);
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
	__lambda8_ (self, _sender, number);
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	Block11Data* _data11_;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp10_;
	NumberPicker* _tmp11_;
	NumberPicker* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gint _tmp15_;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	GtkPopover* _tmp21_;
	NumberPicker* _tmp22_;
	GtkPopover* _tmp23_;
	GtkPopover* _tmp24_;
	g_return_if_fail (self != NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = sudoku_cell_get_popover (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		sudoku_cell_dismiss_popover (self);
		_tmp4_ = sudoku_cell_get_popover (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_popover_get_child (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_NUMBER_PICKER, NumberPicker));
		_tmp9_ = _tmp8_;
		if (!_tmp9_) {
			block11_data_unref (_data11_);
			_data11_ = NULL;
			return;
		}
	}
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
	_tmp10_ = self->priv->game;
	_tmp11_ = number_picker_new (_tmp10_, FALSE);
	g_object_ref_sink (_tmp11_);
	_data11_->number_picker = _tmp11_;
	_tmp12_ = _data11_->number_picker;
	g_signal_connect_data (_tmp12_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp14_ = sudoku_cell_get_value (self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ > 0) {
		_tmp13_ = TRUE;
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
		_tmp16_ = self->priv->game;
		_tmp17_ = sudoku_game_get_board (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp13_ = sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col);
	}
	_tmp19_ = _data11_->number_picker;
	number_picker_set_clear_button_visibility (_tmp19_, _tmp13_);
	_tmp20_ = sudoku_cell_get_popover (self);
	_tmp21_ = _tmp20_;
	_tmp22_ = _data11_->number_picker;
	gtk_popover_set_child (_tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = sudoku_cell_get_popover (self);
	_tmp24_ = _tmp23_;
	gtk_popover_popup (_tmp24_);
	block11_data_unref (_data11_);
	_data11_ = NULL;
}

void
sudoku_cell_check_value_warnings (SudokuCell* self,
                                  gboolean show_extra_warnings)
{
	gboolean _error_ = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_error_ = FALSE;
	_tmp0_ = sudoku_cell_get_value (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != 0) {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		Coord _tmp7_ = {0};
		GtkLabel* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp2_ = self->priv->game;
		_tmp3_ = sudoku_game_get_board (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = sudoku_board_get_broken_coords (_tmp4_);
		_tmp6_ = _tmp5_;
		coord_init (&_tmp7_, self->priv->row, self->priv->col);
		if (gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp7_)) {
			_error_ = TRUE;
		} else {
			gboolean _tmp8_ = FALSE;
			if (show_extra_warnings) {
				SudokuGame* _tmp9_;
				GameMode _tmp10_;
				GameMode _tmp11_;
				_tmp9_ = self->priv->game;
				_tmp10_ = sudoku_game_get_mode (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp8_ = _tmp11_ == GAME_MODE_PLAY;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				gint solution = 0;
				SudokuGame* _tmp12_;
				SudokuBoard* _tmp13_;
				SudokuBoard* _tmp14_;
				_tmp12_ = self->priv->game;
				_tmp13_ = sudoku_game_get_board (_tmp12_);
				_tmp14_ = _tmp13_;
				solution = sudoku_board_get_solution (_tmp14_, self->priv->row, self->priv->col);
				if (solution != 0) {
					gint _tmp15_;
					gint _tmp16_;
					_tmp15_ = sudoku_cell_get_value (self);
					_tmp16_ = _tmp15_;
					_error_ = _tmp16_ != solution;
				}
			}
		}
		_tmp17_ = self->priv->value_label;
		_tmp18_ = sudoku_cell_get_value (self);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strdup_printf ("%i", _tmp19_);
		_tmp21_ = _tmp20_;
		gtk_label_set_label (_tmp17_, _tmp21_);
		_g_free0 (_tmp21_);
	} else {
		SudokuGame* _tmp22_;
		SudokuBoard* _tmp23_;
		SudokuBoard* _tmp24_;
		_tmp22_ = self->priv->game;
		_tmp23_ = sudoku_game_get_board (_tmp22_);
		_tmp24_ = _tmp23_;
		if (sudoku_board_count_possibilities (_tmp24_, self->priv->row, self->priv->col) == 0) {
			GtkLabel* _tmp25_;
			_tmp25_ = self->priv->value_label;
			gtk_label_set_label (_tmp25_, "X");
		}
	}
	if (_error_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
	}
}

void
sudoku_cell_check_earmarks_warnings (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuBoard* _tmp8_;
	gint _tmp9_ = 0;
	gboolean* _tmp10_;
	gint marks_length1;
	gint _marks_size_;
	g_return_if_fail (self != NULL);
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != 0) {
		_tmp0_ = TRUE;
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
		_tmp3_ = self->priv->game;
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp6_ = self->priv->game;
	_tmp7_ = sudoku_game_get_board (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp10_ = sudoku_board_get_earmarks (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
	marks = _tmp10_;
	marks_length1 = _tmp9_;
	_marks_size_ = marks_length1;
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gboolean* _tmp13_;
				gint _tmp13__length1;
				gboolean* _tmp14_;
				gint _tmp14__length1;
				gboolean _tmp15_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = num;
					num = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				_tmp13_ = marks;
				_tmp13__length1 = marks_length1;
				if (!(num <= _tmp13__length1)) {
					break;
				}
				_tmp14_ = marks;
				_tmp14__length1 = marks_length1;
				_tmp15_ = _tmp14_[num - 1];
				if (_tmp15_) {
					sudoku_cell_check_earmark_warnings (self, num);
				}
			}
		}
	}
	marks = (g_free (marks), NULL);
}

void
sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                    gint num)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!sudoku_board_is_possible (_tmp2_, self->priv->row, self->priv->col, num)) {
		GtkLabel** _tmp3_;
		gint _tmp3__length1;
		GtkLabel* _tmp4_;
		_tmp3_ = self->priv->earmark_labels;
		_tmp3__length1 = self->priv->earmark_labels_length1;
		_tmp4_ = _tmp3_[num - 1];
		gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "error");
	} else {
		GtkLabel** _tmp5_;
		gint _tmp5__length1;
		GtkLabel* _tmp6_;
		_tmp5_ = self->priv->earmark_labels;
		_tmp5__length1 = self->priv->earmark_labels_length1;
		_tmp6_ = _tmp5_[num - 1];
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "error");
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp4_ = sudoku_board_get_earmarks (_tmp2_, self->priv->row, self->priv->col, &_tmp3_);
	marks = _tmp4_;
	marks_length1 = _tmp3_;
	_marks_size_ = marks_length1;
	_tmp5_ = self->priv->value_label;
	_tmp6_ = sudoku_cell_get_value (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
	_tmp9_ = _tmp8_;
	gtk_label_set_label (_tmp5_, _tmp9_);
	_g_free0 (_tmp9_);
	gtk_widget_remove_css_class ((GtkWidget*) self, "error");
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				gboolean* _tmp12_;
				gint _tmp12__length1;
				GtkLabel** _tmp13_;
				gint _tmp13__length1;
				GtkLabel* _tmp14_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = num;
					num = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				_tmp12_ = marks;
				_tmp12__length1 = marks_length1;
				if (!(num <= _tmp12__length1)) {
					break;
				}
				_tmp13_ = self->priv->earmark_labels;
				_tmp13__length1 = self->priv->earmark_labels_length1;
				_tmp14_ = _tmp13_[num - 1];
				gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "error");
			}
		}
	}
	marks = (g_free (marks), NULL);
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
	self = (SudokuCell*) base;
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp0_ = self->priv->value_label;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
	return self ? gsk_transform_ref (self) : NULL;
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	graphene_point_t _tmp4_;
	GskTransform* _tmp5_;
	GtkLabel* _tmp6_;
	GskTransform* _tmp7_;
	GskTransform* _tmp8_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint num = 0;
	self = (SudokuCell*) base;
	_tmp0_ = sudoku_cell_get_popover (self);
	_tmp1_ = _tmp0_;
	gtk_popover_present (_tmp1_);
	value_height = MIN (width, height);
	value_width = value_height;
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
	_tmp2_ = gsk_transform_new ();
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
	_tmp4_ = *graphene_point_init (&_tmp3_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
	_tmp5_ = gsk_transform_translate (_tmp2_, &_tmp4_);
	center = _tmp5_;
	_tmp6_ = self->priv->value_label;
	_tmp7_ = center;
	_tmp8_ = _gsk_transform_ref0 (_tmp7_);
	gtk_widget_allocate ((GtkWidget*) _tmp6_, value_width, value_height, baseline, _tmp8_);
	_tmp9_ = self->priv->game;
	_tmp10_ = sudoku_game_get_board (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
	_tmp13_ = _tmp12_;
	earmark_width = width / _tmp13_;
	_tmp14_ = self->priv->game;
	_tmp15_ = sudoku_game_get_board (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
	_tmp18_ = _tmp17_;
	earmark_height = height / _tmp18_;
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp21_;
				SudokuBoard* _tmp22_;
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				if (!_tmp19_) {
					gint _tmp20_;
					_tmp20_ = row_tmp;
					row_tmp = _tmp20_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp21_ = self->priv->game;
				_tmp22_ = sudoku_game_get_board (_tmp21_);
				_tmp23_ = _tmp22_;
				_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
				_tmp25_ = _tmp24_;
				if (!(row_tmp < _tmp25_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp26_ = FALSE;
						_tmp26_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp28_;
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp35_;
							graphene_point_t _tmp36_ = {0};
							SudokuGame* _tmp37_;
							SudokuBoard* _tmp38_;
							SudokuBoard* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							graphene_point_t _tmp42_;
							GskTransform* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
							GskTransform* _tmp46_;
							GskTransform* _tmp47_;
							if (!_tmp26_) {
								gint _tmp27_;
								_tmp27_ = col_tmp;
								col_tmp = _tmp27_ + 1;
							}
							_tmp26_ = FALSE;
							_tmp28_ = self->priv->game;
							_tmp29_ = sudoku_game_get_board (_tmp28_);
							_tmp30_ = _tmp29_;
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
							_tmp32_ = _tmp31_;
							if (!(col_tmp < _tmp32_)) {
								break;
							}
							_tmp33_ = num;
							num = _tmp33_ + 1;
							_tmp34_ = self->priv->earmark_labels;
							_tmp34__length1 = self->priv->earmark_labels_length1;
							sudoku_cell_set_font_size (self, &_tmp34_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
							_tmp35_ = gsk_transform_new ();
							memset (&_tmp36_, 0, sizeof (graphene_point_t));
							_tmp37_ = self->priv->game;
							_tmp38_ = sudoku_game_get_board (_tmp37_);
							_tmp39_ = _tmp38_;
							_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
							_tmp41_ = _tmp40_;
							_tmp42_ = *graphene_point_init (&_tmp36_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp41_ - row_tmp) - 1) * earmark_height));
							_tmp43_ = gsk_transform_translate (_tmp35_, &_tmp42_);
							earmark_position = _tmp43_;
							_tmp44_ = self->priv->earmark_labels;
							_tmp44__length1 = self->priv->earmark_labels_length1;
							_tmp45_ = _tmp44_[num - 1];
							_tmp46_ = earmark_position;
							_tmp47_ = _gsk_transform_ref0 (_tmp46_);
							gtk_widget_allocate ((GtkWidget*) _tmp45_, earmark_width, earmark_height, baseline, _tmp47_);
							_gsk_transform_unref0 (earmark_position);
						}
					}
				}
			}
		}
	}
	_gsk_transform_unref0 (center);
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
	return self ? pango_attr_list_ref (self) : NULL;
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (*label != NULL);
	_tmp0_ = gtk_label_get_attributes (*label);
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
	attr_list = _tmp1_;
	_tmp2_ = attr_list;
	if (_tmp2_ == NULL) {
		PangoAttrList* _tmp3_;
		_tmp3_ = pango_attr_list_new ();
		_pango_attr_list_unref0 (attr_list);
		attr_list = _tmp3_;
	}
	_tmp4_ = attr_list;
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
	pango_attr_list_change (_tmp4_, _tmp5_);
	_tmp6_ = attr_list;
	gtk_label_set_attributes (*label, _tmp6_);
	_pango_attr_list_unref0 (attr_list);
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_popover;
	if (_tmp0_ != NULL) {
		GtkPopover* _tmp1_;
		_tmp1_ = self->priv->_popover;
		gtk_popover_popdown (_tmp1_);
	}
}

GtkPopover*
sudoku_cell_get_popover (SudokuCell* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_popover;
	if (_tmp0_ == NULL) {
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
		_tmp1_ = (GtkPopover*) gtk_popover_new ();
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->_popover);
		self->priv->_popover = _tmp1_;
		_tmp2_ = self->priv->_popover;
		gtk_popover_set_autohide (_tmp2_, FALSE);
	}
	_tmp3_ = self->priv->_popover;
	result = _tmp3_;
	return result;
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
	return result;
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->game;
	_tmp2_ = sudoku_game_get_board (_tmp1_);
	_tmp3_ = _tmp2_;
	if (value == sudoku_board_get (_tmp3_, self->priv->row, self->priv->col)) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = sudoku_cell_get_is_fixed (self);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_;
	}
	if (_tmp0_) {
		return;
	}
	if (value != 0) {
		GtkLabel* _tmp6_;
		_tmp6_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	} else {
		GtkLabel* _tmp7_;
		_tmp7_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
	}
	if (value == 0) {
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
		_tmp8_ = self->priv->game;
		_tmp9_ = sudoku_game_get_board (_tmp8_);
		_tmp10_ = _tmp9_;
		if (sudoku_board_get (_tmp10_, self->priv->row, self->priv->col) != 0) {
			SudokuGame* _tmp11_;
			_tmp11_ = self->priv->game;
			sudoku_game_remove (_tmp11_, self->priv->row, self->priv->col);
		}
	} else {
		GtkLabel* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		SudokuGame* _tmp15_;
		_tmp12_ = self->priv->value_label;
		_tmp13_ = g_strdup_printf ("%i", value);
		_tmp14_ = _tmp13_;
		gtk_label_set_label (_tmp12_, _tmp14_);
		_g_free0 (_tmp14_);
		_tmp15_ = self->priv->game;
		sudoku_game_insert (_tmp15_, self->priv->row, self->priv->col, value);
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
	return result;
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_selected;
	return result;
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_selected = value;
	sudoku_cell_set_fixed_css (self, !value);
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighted_background;
	return result;
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlighted_background = value;
	sudoku_cell_set_fixed_css (self, !value);
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighted_value;
	return result;
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->_highlighted_value = value;
	if (value) {
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_get_paused (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_paused;
	return result;
}

void
sudoku_cell_set_paused (SudokuCell* self,
                        gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_paused = value;
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "paused");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "paused");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY]);
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_POPOVER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_POPOVER_PROPERTY] = g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_PAUSED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL] = g_signal_new ("will-open-popover", TYPE_SUDOKU_CELL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel** _tmp4_;
	self->priv = sudoku_cell_get_instance_private (self);
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
	self->priv->button_controller = _tmp0_;
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
	self->priv->long_press_controller = _tmp1_;
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	self->priv->key_controller = _tmp2_;
	self->priv->_popover = NULL;
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	g_object_ref_sink (_tmp3_);
	self->priv->value_label = _tmp3_;
	_tmp4_ = g_new0 (GtkLabel*, 8 + 1);
	self->priv->earmark_labels = _tmp4_;
	self->priv->earmark_labels_length1 = 8;
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
	self->priv->_selected = FALSE;
	self->priv->_highlighted_background = FALSE;
	self->priv->_highlighted_value = FALSE;
	self->priv->_paused = FALSE;
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
	_g_object_unref0 (self->priv->game);
	_g_object_unref0 (self->priv->button_controller);
	_g_object_unref0 (self->priv->long_press_controller);
	_g_object_unref0 (self->priv->key_controller);
	_g_object_unref0 (self->priv->_popover);
	_g_object_unref0 (self->priv->value_label);
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_POPOVER_PROPERTY:
		g_value_set_object (value, sudoku_cell_get_popover (self));
		break;
		case SUDOKU_CELL_VALUE_PROPERTY:
		g_value_set_int (value, sudoku_cell_get_value (self));
		break;
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
		break;
		case SUDOKU_CELL_PAUSED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_paused (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_VALUE_PROPERTY:
		sudoku_cell_set_value (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_PAUSED_PROPERTY:
		sudoku_cell_set_paused (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

